#ifndef QUBX_IDEALIZE_MDL_H
#define QUBX_IDEALIZE_MDL_H

#include "qubxidlmdl.h"

#ifdef __cplusplus
extern "C" {
#endif

QUBXIDLMDL_API void* qubx_idealize_mdl_context_create();
QUBXIDLMDL_API void qubx_idealize_mdl_context_free(void *ctx);

QUBXIDLMDL_API void* qubx_idealizer_mdl_create(void *ctx);
QUBXIDLMDL_API void qubx_idealizer_mdl_free(void *idlz);
  
QUBXIDLMDL_API int qubx_idealizer_mdl_idealize(void *idlz, float *data, int N, int Lmin, int split3, int combineClose, float combineDelta); // returns dwell count
QUBXIDLMDL_API void qubx_idealizer_mdl_interrupt(void *idlz);

  // split3: nonzero to also try splitting intervals at two breakpoints before giving up (slower)
QUBXIDLMDL_API int qubx_idealizer_mdl_get_dwells(void *idlz, int *counts, float *amps, float *stds, int capacity);
QUBXIDLMDL_API int qubx_idealizer_mdl_get_dwells_fl(void *idlz, int first_index, int *ff, int *ll, float *amps, float *stds, int capacity);

#ifdef __cplusplus
}
#endif

#endif
